# lib/rpminstall.c File Reference

`#include "system.h"`
`#include <rpmio.h>`
`#include <rpmtag.h>`
`#include <rpmcli.h>`
`#include "rpmdb.h"`
`#include "rpmte.h"`
`#include "manifest.h"`
`#include "rpmgi.h"`
`#include "debug.h"`

Include dependency graph for rpminstall.c:

Go to the source code of this file.

## Defines

#define | _RPMTS_INTERNAL

## Functions

static void | printHash (const uint64_t amount, const uint64_t total)
| Print a CLI progress bar.
void * | rpmShowProgress (const void *arg, const rpmCallbackType what, const uint64_t amount, const uint64_t total, fnpyKey key, void *data)
| The rpm CLI generic transaction callback handler.
int | rpmcliInstallProblems (rpmts ts, const char *msg, int rc)
| Report package problems (if any).
int | rpmcliInstallSuggests (rpmts ts)
| Report packages(if any) that satisfy unresolved dependencies.
int | rpmcliInstallCheck (rpmts ts)
| Check package element dependencies in a transaction set, reporting problems.
int | rpmcliInstallOrder (rpmts ts)
| Order package elements in a transaction set, reporting problems.
int | rpmcliInstallRun (rpmts ts, rpmps okProbs, rpmprobFilterFlags ignoreSet)
| Install/erase package elements in a transaction set, reporting problems.
int | rpmcliInstall (rpmts ts, QVA_t ia, const char **argv)
| Install/upgrade/freshen binary rpm package.
int | rpmErase (rpmts ts, QVA_t ia, const char **argv)
| Erase binary rpm package.
int | rpmInstallSource (rpmts ts, const char *arg, const char **specFilePtr, const char **cookie)
| Install source rpm package.

## Variables

int | rpmcliPackagesTotal = 0
int | rpmcliHashesCurrent = 0
int | rpmcliHashesTotal = 0
uint64_t | rpmcliProgressCurrent = 0
uint64_t | rpmcliProgressTotal = 0

## Detailed Description

Definition in file rpminstall.c.

## Define Documentation

#define _RPMTS_INTERNAL

Definition at line 9 of file rpminstall.c.

## Function Documentation

static void printHash | ( | const uint64_t | amount,
|  | const uint64_t | total |
| ) |  |  | `[static]`

Print a CLI progress bar.

Todo:
  Unsnarl isatty(STDOUT_FILENO) from the control flow.

Parameters:

  | amount | current
  | total | final

Definition at line 44 of file rpminstall.c.

References rpmcliHashesCurrent, rpmcliHashesTotal, rpmcliProgressCurrent, and rpmcliProgressTotal.

Referenced by rpmShowProgress().

## Variable Documentation

int rpmcliHashesCurrent = 0

Definition at line 30 of file rpminstall.c.

Referenced by printHash(), and rpmShowProgress().

int rpmcliHashesTotal = 0

Definition at line 32 of file rpminstall.c.

Referenced by printHash().

int rpmcliPackagesTotal = 0

Definition at line 28 of file rpminstall.c.

Referenced by rpmcliInstall(), rpmRollback(), rpmShowProgress(), and rpmtsAddInstallElement().

uint64_t rpmcliProgressCurrent = 0

Definition at line 34 of file rpminstall.c.

Referenced by printHash(), and rpmShowProgress().

uint64_t rpmcliProgressTotal = 0

Definition at line 36 of file rpminstall.c.

Referenced by printHash(), and rpmShowProgress().